/* --------------------------------------------------------- */
/*	BAS Simulator front end									 */
/* ========================================================= */
/*	(C)2005 t.hara											 */
/* --------------------------------------------------------- */

#include <stdio.h>
#include <malloc.h>
#include "bassim.h"

/* --------------------------------------------------------- */
static void _Usage( void ) {

	fprintf( stderr, "BAS Simulator Copyright(C)2005 t.hara\n" );
	fprintf( stderr, "Usage> bassim <bin file>\n" );
}

/* --------------------------------------------------------- */
static unsigned char *fileLoad( const char *pFileName, long *pSize ) {
	FILE *pFile;
	unsigned char *pImage;

	pFile = fopen( pFileName, "r" );
	if( pFile == NULL ) return NULL;

	fseek( pFile, 0, SEEK_END );
	*pSize = ftell( pFile );
	fseek( pFile, 0, SEEK_SET );

	pImage = (unsigned char*) calloc( *pSize + 3, sizeof(char) );
	if( pImage == NULL ) {
		fclose( pFile );
		return NULL;
	}

	fread( pImage, 1, *pSize, pFile );
	fclose( pFile );
	return pImage;
}

/* --------------------------------------------------------- */
int main( int argc, char *argv[] ) {
	unsigned char *pMemory;
	long Size;

	if( argc < 2 ) {
		_Usage();
		return 1;
	}
	pMemory = fileLoad( argv[1], &Size );
	if( pMemory == NULL ) {
		fprintf( stderr, "Cannot open %s.\n", argv[1] );
		return 1;
	}
	if( Size > 65535 ) {
		fprintf( stderr, "Size too big.\n" );
	}
	else {
		bassimRun( pMemory, (unsigned short) Size );
	}
	free( pMemory );
	return 0;
}
